import java.util.Iterator;
import java.util.LinkedList;
import java.util.PriorityQueue;
import java.util.Random;

/**
 *
 * @author Joost
 */
public class RK_GA_CorrectMyWrongs extends ModifiedRK_GA implements GeneticStrategy {
	
	@Override
	public void iterate(PriorityQueue<Specimen> population) {
		Iterator<Specimen> it = population.iterator();
		LinkedList<Specimen> resultlist = new LinkedList<Specimen>(); 
		for (int j = 0; j < GA.POPSIZE/2; j++) {
			double sumOfCMWDist = 0;
			int[] distlist = new int[GA.POPSIZE]; 
			int i = 0;
			Specimen s = it.next();
			for (Specimen p:population) {
				distlist[i] = s.errorDist(p);
				sumOfCMWDist += distlist[i];
				i++;
			}
			Random r = new Random();
			double rd = r.nextDouble();
			double n = 0;
			i = -1;
			Iterator<Specimen> it2 = population.iterator();
			Specimen s2;
			do {
				s2 = it2.next();
				i++;
				n += distlist[i] / sumOfCMWDist;
			} while (n < rd);
			Specimen[] specs = twoPointCrossOver(s, s2);
			specs[0] = mutate(specs[0]);
			specs[0].setFitness(fitness(specs[0]));
			specs[1] = mutate(specs[1]);
			specs[1].setFitness(fitness(specs[1]));
			resultlist.add(specs[0]);
			resultlist.add(specs[1]);
		}
		population.addAll(resultlist);
	}
}
